/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "DataView.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void MyReal_Initialize(MyReal* pVal)
{
    *pVal = (MyReal) 0.00000000000000000000E+000;
}
#endif

 
flag MyReal_IsConstraintValid(const MyReal* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (0.00000000000000000000E+000 <= *pVal && *pVal <= 1.00000000000000000000E+002);
	*pErrCode = ret ? 0 : ERR_MyReal;

	return ret;
}

flag MyReal_Encode(const MyReal* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? MyReal_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeReal(pBitStrm, *pVal);
    }

	return ret;
}

flag MyReal_Decode(MyReal* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	BitStream_DecodeReal(pBitStrm, pVal);
	*pErrCode = ret ? 0 : 268435457;

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void MyComp_Initialize(MyComp* pVal)
{
    *pVal = (MyComp) cA;
}
#endif

 
flag MyComp_IsConstraintValid(const MyComp* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = ((*pVal == cA) || (*pVal == cB));
	*pErrCode = ret ? 0 : ERR_MyComp;

	return ret;
}

flag MyComp_Encode(const MyComp* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? MyComp_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    switch(*pVal) 
	    {
	        case cA:   
	            BitStream_EncodeConstraintWholeNumber(pBitStrm, 0, 0, 1);
	        	break;
	        case cB:   
	            BitStream_EncodeConstraintWholeNumber(pBitStrm, 1, 0, 1);
	        	break;
	        default:
	    	    *pErrCode = 1073741825; //COVERAGE_IGNORE
	    	    ret = FALSE;            //COVERAGE_IGNORE
	    }
    }

	return ret;
}

flag MyComp_Decode(MyComp* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	asn1SccSint enumIndex;

	ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &enumIndex, 0, 1);
	*pErrCode = ret ? 0 : 268435458;
	if (ret) {
	    switch(enumIndex) 
	    {
	        case 0: 
	            *pVal = cA;
	            break;
	        case 1: 
	            *pVal = cB;
	            break;
	        default:
		        *pErrCode = 1073741826;     //COVERAGE_IGNORE
		        ret = FALSE;                //COVERAGE_IGNORE
	    }
	}

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void Prod_Initialize(Prod* pVal)
{
    *pVal = (Prod) {
    .comp = cA,
    .value = 0.00000000000000000000E+000
};
}
#endif

 
flag Prod_IsConstraintValid(const Prod* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = MyComp_IsConstraintValid(&pVal->comp, pErrCode);
	if (ret) {
	    ret = MyReal_IsConstraintValid(&pVal->value, pErrCode);
	
	}

	return ret;
}

flag Prod_Encode(const Prod* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? Prod_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode comp */
	    ret = MyComp_Encode(&pVal->comp, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode value */
	        ret = MyReal_Encode(&pVal->value, pBitStrm, pErrCode, FALSE);
	    
	    }
    }

	return ret;
}

flag Prod_Decode(Prod* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode comp */
	ret = MyComp_Decode(&pVal->comp, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode value */
	    ret = MyReal_Decode(&pVal->value, pBitStrm, pErrCode);
	
	}


	return ret;
}

